section .text

%xdefine	nrep	200
%xdefine	nloop	1000

align 16
dwinit	dd	00000002h
		dd	00000005h
		dd	00000009h
		dd	0000000bh
dwmask	dd	0000001fh
		dd	0000001fh
		dd	0000001fh
		dd	0000001fh
sbias	dd	0000007fh
		dd	0000007fh
		dd	0000007fh
		dd	0000007fh
dbias	dq	00000000000003ffh
		dq	00000000000003ffh

;=======================================================================

%push
global _gpr_nothing
align 64
_gpr_nothing:
	mov		ecx, nloop
	mov		eax, dword [dwinit]
.looplabel:

%rep nrep
	add		eax, edx
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _gpr_bsr
align 64
_gpr_bsr:
	mov		ecx, nloop
	mov		eax, dword [dwinit]
.looplabel:

%rep nrep
	bsr		edx, eax

	add		eax, edx
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_nothing
align 64
_sse_nothing:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_only
align 64
_sse_cvtdq2ps_only:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	cvtdq2ps	xmm2, xmm1

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtps2dq_only
align 64
_sse_cvtps2dq_only:
	mov		ecx, nloop
	pxor	xmm1, xmm1
.looplabel:

%rep nrep
	cvtps2dq	xmm2, xmm1

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_cvtps2dq
align 64
_sse_cvtdq2ps_cvtps2dq:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	cvtdq2ps	xmm3, xmm1
	cvtps2dq	xmm2, xmm3

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2pd_only
align 64
_sse_cvtdq2pd_only:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	cvtdq2pd	xmm2, xmm1

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_insext_pbsrd
align 64
_sse_insext_pbsrd:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	pextrd		eax, xmm1, 0
	bsr			eax, eax
	pinsrd		xmm2, eax, 0
	pextrd		eax, xmm1, 1
	bsr			eax, eax
	pinsrd		xmm2, eax, 1
	pextrd		eax, xmm1, 2
	bsr			eax, eax
	pinsrd		xmm2, eax, 2
	pextrd		eax, xmm1, 3
	bsr			eax, eax
	pinsrd		xmm2, eax, 3

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_insext_pbsrd_half
align 64
_sse_insext_pbsrd_half:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
.looplabel:

%rep nrep
	pextrd		eax, xmm1, 0
	bsr			eax, eax
	pinsrd		xmm2, eax, 0
	pextrd		eax, xmm1, 1
	bsr			eax, eax
	pinsrd		xmm2, eax, 1

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_pbsrd_nocare
align 64
_sse_cvtdq2ps_pbsrd_nocare:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [sbias]
.looplabel:

%rep nrep
	cvtdq2ps	xmm2, xmm1
	psrld		xmm2, 23
	psubd		xmm2, xmm7

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_pbsrd_msbcare_sse2
align 64
_sse_cvtdq2ps_pbsrd_msbcare_sse2:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [sbias]
	movdqa	xmm6, oword [dwmask]
.looplabel:

%rep nrep
	cvtdq2ps	xmm2, xmm1
	psrld		xmm2, 23
	psubd		xmm2, xmm7

	movdqa		xmm3, xmm1
	psrad		xmm3, 31
	por			xmm2, xmm3
	pand		xmm2, xmm6

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_pbsrd_msbcare_sse41
align 64
_sse_cvtdq2ps_pbsrd_msbcare_sse41:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [sbias]
	movdqa	xmm6, oword [dwmask]
.looplabel:

%rep nrep
	cvtdq2ps	xmm2, xmm1
	psrld		xmm2, 23
	psubd		xmm2, xmm7

	movdqa		xmm0, xmm1
	psrad		xmm0, 31
	pblendvb	xmm2, xmm6, xmm0

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_pbsrd_roundcare
align 64
_sse_cvtdq2ps_pbsrd_roundcare:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [sbias]
	movdqa	xmm6, oword [dwmask]
.looplabel:

%rep nrep
	movdqa		xmm3, xmm1
	psrld		xmm3, 1
	pandn		xmm3, xmm1

	cvtdq2ps	xmm2, xmm3
	psrld		xmm2, 23
	psubd		xmm2, xmm7

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2ps_pbsrd_bothcare_sse41
align 64
_sse_cvtdq2ps_pbsrd_bothcare_sse41:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [sbias]
	movdqa	xmm6, oword [dwmask]
.looplabel:

%rep nrep
	movdqa		xmm3, xmm1
	psrld		xmm3, 1
	pandn		xmm3, xmm1

	cvtdq2ps	xmm2, xmm3
	psrld		xmm2, 23
	psubd		xmm2, xmm7

	movdqa		xmm0, xmm1
	psrad		xmm0, 31
	pblendvb	xmm2, xmm6, xmm0

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop

;=======================================================================

%push
global _sse_cvtdq2pd_pbsrd_nocare
align 64
_sse_cvtdq2pd_pbsrd_nocare:
	mov		ecx, nloop
	movdqa	xmm1, oword [dwinit]
	movdqa	xmm7, oword [dbias]
.looplabel:

%rep nrep
	pshufd		xmm2, xmm1, 0dh
	pshufd		xmm3, xmm1, 08h

	cvtdq2pd	xmm3, xmm3
	psrlq		xmm3, 52
	psubd		xmm3, xmm7

	cvtdq2pd	xmm2, xmm2
	psrlq		xmm2, 52
	psubd		xmm2, xmm7

	psllq		xmm2, 32
	por			xmm2, xmm3

	paddd		xmm1, xmm2
%endrep

	sub		ecx, 1
	jnz		.looplabel

	mov		eax, nrep*nloop
	ret
%pop
